// AsyncFutureApp.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

/*
	std::async, std::future
*/

int main()
{
		//step 1. possibly starts thread immediately
	std::future<int> ft1(std::async(sum, 1, 11));
	std::future<int> ft2(std::async(sum, 1, 101));

	try
	{
		//step 2. to get result we have to call future.get()
		int a = ft1.get();
		int b = ft2.get();

		cout << a << " + " << b << " = " << a + b << endl;
	}
	catch (std::exception& e)
	{
		cout << e.what() << endl;
	}
	
    return 0;
}

